#SSA3XNRSC_AM_Limit.py
#
#This program creates a specific AM NRSC mask using a user defined
#center frequency and saves it as a .LIM file for use with SIGLENT SSA3000X
#Spectrum Analyzers
#
#Rev 062017, Date 6.5.2017
#
#Author: Jason Chonko jason.chonko@siglent.com
#
#Python V2.7.12
#
#This code example is for reference only. No guarantees are implied or expressed.
#Users should ensure that the data is correct for their application before using it.

import sys
from Tkinter import *
import tkMessageBox
import Tkinter
import tkFileDialog

root = Tk()
root.withdraw() #Hide root - This closes asksaveas root window

def Start():
#This function starts the program by asking for user input
#This is designed to make it easier to createmultiple masks
#in one session 
    
    choice = "X"
    while choice not in "YN": #Loop 
        print "Are you ready to build an AM NRSC Mask?"
        choice = raw_input("Enter Y to build a mask, N to close the program: ")
        if choice == 'Y':
            WText()
        if choice == 'N':
            quit()
        else:
            print "Incorrect entry."
            WText()
    return
    
def WText():
#This function writes data to a text file
         
    f = tkFileDialog.asksaveasfile(mode='wb+', defaultextension=".lim") #Open dialog box, binary file type to keep formatting for termination char
    if f is None: #asksaveasfile return `None` if dialog closed with "cancel".
        return

    HeaderData = (b'File,limit\nState,on\nType,upper\nMode,point\nX Axis,frequency\nAmpt Type,0\nLine Level,0.000000e+000\n')
    f.write(HeaderData) #Write header to text file
    #print HeaderData
    
    strCenterFreq = raw_input('Input Center Frequency (XXXX.XXX kHz): ') #Prompt User for input
    strCenterFreq = str("{:.6e}".format(float(strCenterFreq)*1000)) #Format input to scientific notation and for upcoming math and convert to Hz from kHz
    print ("\nCenter Frequency: " + strCenterFreq)

    #The following list builds each mask segment (Frequency in Hz,amplitude in dB) and uses
    #scientific notation for each element
    flt_Segment_List = [str("{:.6e}".format(float(strCenterFreq)-100000))+","+ str("{:.6e}".format(-8.000000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-75000))+","+ str("{:.6e}".format(-8.000000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-75000))+","+ str("{:.6e}".format(-6.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-60000))+","+ str("{:.6e}".format(-6.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-60000))+","+ str("{:.6e}".format(-6.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-30000))+","+ str("{:.6e}".format(-3.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-30000))+","+ str("{:.6e}".format(-3.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-20000))+","+ str("{:.6e}".format(-3.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-20000))+","+ str("{:.6e}".format(-2.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-10200))+","+ str("{:.6e}".format(-2.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)-10200))+","+ str("{:.6e}".format(0.000000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+10200))+","+ str("{:.6e}".format(0.000000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+10200))+","+ str("{:.6e}".format(-2.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+20000))+","+ str("{:.6e}".format(-2.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+20000))+","+ str("{:.6e}".format(-3.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+30000))+","+ str("{:.6e}".format(-3.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+30000))+","+ str("{:.6e}".format(-3.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+60000))+","+ str("{:.6e}".format(-6.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+60000))+","+ str("{:.6e}".format(-6.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+75000))+","+ str("{:.6e}".format(-6.500000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+75000))+","+ str("{:.6e}".format(-8.000000e+001)),
                        str("{:.6e}".format(float(strCenterFreq)+100000))+","+ str("{:.6e}".format(-8.000000e+001)),
                      ]

    #print(flt_SegData_List[0], flt_SegData_List[1])

    print "\nFrequency (Hz)    Amplitude (dB)"
    for item in flt_Segment_List:
       print "%s" % item
       f.write(u"%s" % item+'\n')
    
    f.close()
    print "\nMask file has been generated"
    choice = raw_input("\nEnter Y to build another mask, N to close the program: ")
    if choice == 'Y':
        WText()
    if choice == 'N':
        quit()
    else:
        print "Incorrect entry."
        WText()
    return


Start()


                           
    

